<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_102) on Thu Mar 15 23:03:53 CET 2018 -->
<title>DrawModel (JDraw API)</title>
<meta name="date" content="2018-03-15">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DrawModel (JDraw API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6,"i7":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../jdraw/framework/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DrawModel.html">Use</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../jdraw/framework/DrawGrid.html" title="interface in jdraw.framework"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../jdraw/framework/DrawModelEvent.html" title="class in jdraw.framework"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?jdraw/framework/DrawModel.html" target="_top">Frames</a></li>
<li><a href="DrawModel.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">jdraw.framework</div>
<h2 title="Interface DrawModel" class="title">Interface DrawModel</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public interface <span class="typeNameLabel">DrawModel</span></pre>
<div class="block">The class DrawModel represents the model of a drawing, i.e.
 all figures stored in a graphic. Every draw view refers to a
 model.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>2.5</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Dominik Gruntz &amp; Christoph Denzler</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../jdraw/framework/DrawView.html" title="interface in jdraw.framework"><code>DrawView</code></a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#addFigure-jdraw.framework.Figure-">addFigure</a></span>(<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&nbsp;f)</code>
<div class="block">Adds a new figure to the draw model.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#addModelChangeListener-jdraw.framework.DrawModelListener-">addModelChangeListener</a></span>(<a href="../../jdraw/framework/DrawModelListener.html" title="interface in jdraw.framework">DrawModelListener</a>&nbsp;listener)</code>
<div class="block">Adds the specified model listener to receive model events from this draw
 model.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../../jdraw/framework/DrawCommandHandler.html" title="interface in jdraw.framework">DrawCommandHandler</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#getDrawCommandHandler--">getDrawCommandHandler</a></span>()</code>
<div class="block">Returns the draw command handler provided by this model.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>java.lang.Iterable&lt;<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#getFigures--">getFigures</a></span>()</code>
<div class="block">Returns an iterator which can be used to iterate over all figures of a
 draw model.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#removeAllFigures--">removeAllFigures</a></span>()</code>
<div class="block">Remove all figures from the draw model.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#removeFigure-jdraw.framework.Figure-">removeFigure</a></span>(<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&nbsp;f)</code>
<div class="block">Removes a given figure from the draw model.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#removeModelChangeListener-jdraw.framework.DrawModelListener-">removeModelChangeListener</a></span>(<a href="../../jdraw/framework/DrawModelListener.html" title="interface in jdraw.framework">DrawModelListener</a>&nbsp;listener)</code>
<div class="block">Removes the specified model listener so that it no longer receives model
 events from this draw model.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../jdraw/framework/DrawModel.html#setFigureIndex-jdraw.framework.Figure-int-">setFigureIndex</a></span>(<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&nbsp;f,
              int&nbsp;index)</code>
<div class="block">Sets the index of a given figure.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="addFigure-jdraw.framework.Figure-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addFigure</h4>
<pre>void&nbsp;addFigure(<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&nbsp;f)</pre>
<div class="block">Adds a new figure to the draw model.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>f</code> - figure to be added to draw model.</dd>
</dl>
</li>
</ul>
<a name="removeFigure-jdraw.framework.Figure-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeFigure</h4>
<pre>void&nbsp;removeFigure(<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&nbsp;f)</pre>
<div class="block">Removes a given figure from the draw model.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>f</code> - figure to be removed from draw model.</dd>
</dl>
</li>
</ul>
<a name="removeAllFigures--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeAllFigures</h4>
<pre>void&nbsp;removeAllFigures()</pre>
<div class="block">Remove all figures from the draw model. This method is used when loading a drawing from a file
 in order to clear the old drawing before loading the new one.</div>
</li>
</ul>
<a name="getFigures--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFigures</h4>
<pre>java.lang.Iterable&lt;<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&gt;&nbsp;getFigures()</pre>
<div class="block">Returns an iterator which can be used to iterate over all figures of a
 draw model. The iterator ordering is the order in which elements were
 inserted into the model (insertion-order). The order is interpreted by
 the view as "back-to-front".</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>iterator to iterate over the draw model</dd>
</dl>
</li>
</ul>
<a name="addModelChangeListener-jdraw.framework.DrawModelListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addModelChangeListener</h4>
<pre>void&nbsp;addModelChangeListener(<a href="../../jdraw/framework/DrawModelListener.html" title="interface in jdraw.framework">DrawModelListener</a>&nbsp;listener)</pre>
<div class="block">Adds the specified model listener to receive model events from this draw
 model.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - the draw model listener.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../jdraw/framework/DrawModelListener.html" title="interface in jdraw.framework"><code>DrawModelListener</code></a></dd>
</dl>
</li>
</ul>
<a name="removeModelChangeListener-jdraw.framework.DrawModelListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeModelChangeListener</h4>
<pre>void&nbsp;removeModelChangeListener(<a href="../../jdraw/framework/DrawModelListener.html" title="interface in jdraw.framework">DrawModelListener</a>&nbsp;listener)</pre>
<div class="block">Removes the specified model listener so that it no longer receives model
 events from this draw model. This method performs no function, nor does
 it throw an exception, if the listener specified by the argument was not
 previously added to this figure.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - the draw model listener.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../jdraw/framework/DrawModelListener.html" title="interface in jdraw.framework"><code>DrawModelListener</code></a></dd>
</dl>
</li>
</ul>
<a name="getDrawCommandHandler--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDrawCommandHandler</h4>
<pre><a href="../../jdraw/framework/DrawCommandHandler.html" title="interface in jdraw.framework">DrawCommandHandler</a>&nbsp;getDrawCommandHandler()</pre>
<div class="block">Returns the draw command handler provided by this model.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the draw command handler used.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../jdraw/framework/DrawCommandHandler.html" title="interface in jdraw.framework"><code>DrawCommandHandler</code></a></dd>
</dl>
</li>
</ul>
<a name="setFigureIndex-jdraw.framework.Figure-int-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setFigureIndex</h4>
<pre>void&nbsp;setFigureIndex(<a href="../../jdraw/framework/Figure.html" title="interface in jdraw.framework">Figure</a>&nbsp;f,
                    int&nbsp;index)
             throws java.lang.IllegalArgumentException,
                    java.lang.IndexOutOfBoundsException</pre>
<div class="block">Sets the index of a given figure. The order of the other figures in the
 model remains unchanged.
 
 If the figure is moved to a new place, then the model sends a
 <code>DRAWING_CHANGED</code> event to all registered model listeners.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>f</code> - the figure whose index has to be set</dd>
<dd><code>index</code> - the position at which the new figure should appear. The other
            figures are moved away.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code> - if the figure is not contained in the model.</dd>
<dd><code>java.lang.IndexOutOfBoundsException</code> - if the index is out of range (
             <tt>index &lt; 0 || index &ge; size()</tt>) where size() is
             the number of figures contained in the model.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../jdraw/framework/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DrawModel.html">Use</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../jdraw/framework/DrawGrid.html" title="interface in jdraw.framework"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../jdraw/framework/DrawModelEvent.html" title="class in jdraw.framework"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?jdraw/framework/DrawModel.html" target="_top">Frames</a></li>
<li><a href="DrawModel.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small><i>Copyright &#169; 2000-2017 D. Gruntz & Ch. Denzler, FHNW. All Rights Reserved.</i></small></p>
</body>
</html>
